<?php

namespace App\Http\Controllers\Common;

use App\Models\Accounts;
use App\Http\Controllers\Controller;
use App\Models\Apierrorlog;
use App\Models\Tallycompany;
use Illuminate\Http\Request;
use App\Models\TallyConnection;
use App\Http\Traits\Company;
use App\Http\Traits\Requestresponse;
use Log;
class CompanyController extends Controller
{
    use Company;
    use Requestresponse;
    public function updateCompany(Request $request)
    {
        $validated = $request->validate([
            'seller_id' => 'required',
            'module'=> 'required',
            'company_id' => 'required',
            'company_name' => 'required',
        ]);

        $data = [];
        $seller_id = $request->seller_id;
        $company_id = $request->company_id;
        $company_name = $request->company_name;
        $connectionDetails = TallyConnection::checkTallyConnection($seller_id, $request->module);
        if(!empty($connectionDetails)){
            $ident = "updateCompanyData-".$seller_id."-".$connectionDetails->id;
            list($reqDataAry,$extraData) = $this->updateCompanyXml($connectionDetails,$company_name,$company_id);
            
            $response= $this->tallyApi($connectionDetails,$ident,"updateCompanyData",$reqDataAry,$extraData);
            
            if($response->success){
                $updateData = ['company_update_flag' => 0];
				Tallycompany::updateCompanyData($request->seller_id, $request->module, $updateData);
            }
            $data = $this->handleResponse($response);
        }else{
            $data['success'] = false;
            $data['message'] = "Tally not connected";
            $code= 401;
        }
        return $data;
       
    }
    
    public function companyList(Request $request){
        $seller_id = $request->seller_id;
        $connectionDetails = TallyConnection::checkTallyConnection($seller_id, $request->module);
        if(!empty($connectionDetails)){
            $ident="CompanyList-". $request->seller_id."-".$connectionDetails->id;
            list($reqDataAry,$extraData) = $this->getCompanyListXml($connectionDetails);
            $companyListResponse = $this->tallyApi($connectionDetails,$ident,"CompanyList",$reqDataAry,$extraData);

            if($companyListResponse->success){
                $updateData = ['company_list_flag' => 0];
                Tallycompany::updateCompanyData($request->seller_id, $request->module, $updateData);
                
            }
            $data = $this->handleResponse($companyListResponse);
        }else{
            $data['success'] = false;
            $data['message'] = "Tally not connected";
            $code= 401;
        }
        return $data;
    }
}
