<?php

namespace App\Http\Controllers\Individual;

use App\Helpers\Helper;
use App\Models\Apierrorlog;
use App\Models\Tallysummary;
use Illuminate\Http\Request;
use App\Models\TallyConnection;
use App\Models\Tallycronongoing;
use App\Models\TallyOrders;
use App\Models\Tallyrefunds;
use App\Models\Tallyproduct;
use App\Models\Tallypayouts;
use App\Models\Tallysummaryaccmappinglog;
use App\Http\Traits\Journal;
use App\Http\Traits\Item;
use App\Http\Traits\Requestresponse;
use PHPUnit\TextUI\Help;
use App\Http\Controllers\Controller;
use DB;
use Log;

class InvoiceController extends Controller
{
    use Journal;
    use Item;
    use Requestresponse;
    protected $bulkDataObjDetail = array();
    protected $commonControllerObj = array();

    public function createOrderInvoice(Request $request)
    {
        $seller_id = $request->seller_id;
        
        list($tallyConnected, $tallySyncSetting) = $this->getSettings($seller_id);
        //dd($tallySyncSetting);
        if (!empty($tallyConnected) && !empty($tallySyncSetting)) {
            $syncOrder = array('code' => '200', 'message' => "No record found to sync!");
            //$cronOngoingCheck = Tallycronongoing::checkCronOnGoing($tallyConnected['seller_id'], $tallyConnected['module']);
            
            if (!empty($cronOngoingCheck)) {
                return array('code' => '409', 'message' => 'Currently process is going on your store, please try after some time.');
            }
            
            if (empty($request->get('order_number'))) {
                //For individual order sync we will not create entry.
                Tallycronongoing::createCronOnGoing($tallyConnected['seller_id'], $tallyConnected['module'], ucfirst($tallyConnected['marketplace']) . '_Create_Individual_Invoice_DB_to_TALLY');
            }

            if(empty($request->get('order_id'))){
                $dbOrders = TallyOrders::fetchUnsyncOrders($tallyConnected, $request, 'create');
                if((empty($request->get('status')) || strtolower($request->get('status')) == 'sync') && empty($request->get('order_number')))
                    $dbOrdersUpdate = TallyOrders::fetchUnsyncOrders($tallyConnected, $request, 'update', array_column($dbOrders, 'id'));
                else
                    $dbOrdersUpdate = array();

                $dbOrders = array_merge($dbOrders, $dbOrdersUpdate);
            }else{
                $dbOrders = TallyOrders::getIndividualOrder($tallyConnected['seller_id'],$request->get('order_id'));
            }

            if (!empty($dbOrders)) {
                $syncOrder = $this->syncOrderData($tallyConnected, $tallySyncSetting, $dbOrders);
            }
            //Delete cron on going
            Tallycronongoing::deleteCronOnGoing($tallyConnected['seller_id'], $tallyConnected['module']);
            
            return $syncOrder; 
        
        } else if (empty($tallyConnected)) {
            return array('code' => '408', 'message' => 'Invalid Seller!');
        } else if (empty($tallySyncSetting)) {
            return array('code' => '408', 'message' => "Seller's Settings not found!");
        }
    }

    public function createRefundCreditNote(Request $request)
    {
        $seller_id = $request->seller_id;

        list($tallyConnected, $tallySyncSetting) = $this->getSettings($seller_id);
        //dd($tallySyncSetting);
        if (!empty($tallyConnected) && !empty($tallySyncSetting)) {
            $syncOrder = array('code' => '200', 'message' => "No record found to sync!");
            //$cronOngoingCheck = Tallycronongoing::checkCronOnGoing($tallyConnected['seller_id'], $tallyConnected['module']);
            
            if (!empty($cronOngoingCheck)) {
                return array('code' => '409', 'message' => 'Currently process is going on your store, please try after some time.');
            }
            
            if (empty($request->get('order_number'))) {
                //For individual order sync we will not create entry.
                Tallycronongoing::createCronOnGoing($tallyConnected['seller_id'], $tallyConnected['module'], ucfirst($tallyConnected['marketplace']) . '_Create_Summary_Invoice_DB_to_TALLY');
            }
            $dbRefunds = Tallyrefunds::fetchUnsyncRefunds($tallyConnected, $request, 'create');

            if((empty($request->get('status')) || strtolower($request->get('status')) == 'sync') && empty($request->get('order_number')))
                $dbRefundsUpdate = Tallyrefunds::fetchUnsyncRefunds($tallyConnected, $request, 'update', array_column($dbRefunds, 'id'));
            else
                $dbRefundsUpdate = array();

            $dbRefunds = array_merge($dbRefunds, $dbRefundsUpdate);

            if (!empty($dbRefunds)) {
                $syncOrder = $this->syncOrderData($tallyConnected, $tallySyncSetting, $dbRefunds,'refund');
            }

            //Delete cron on going
            Tallycronongoing::deleteCronOnGoing($tallyConnected['seller_id'], $tallyConnected['module']);
            
            return $syncOrder; 
        
        } else if (empty($tallyConnected)) {
            return array('code' => '408', 'message' => 'Invalid Seller!');
        } else if (empty($tallySyncSetting)) {
            return array('code' => '408', 'message' => "Seller's Settings not found!");
        }
    }

    public function syncOrderData($tallyConnected, $tallySyncSetting, $dbOrders,$sync = 'order')
    {
        foreach ($dbOrders as  $order) {
            $lineItemData= [];
            foreach($order['line_items'] as $key => $lineItem){
                if($lineItem['line_item_type'] == 'Product'){
                    if($tallySyncSetting['product_creation'] == 'SAME'){
                        $product_name_to_match = $tallySyncSetting['product_name'];
                    }else{
                        $product_name_to_match = $this->getProductNametoMatch($tallySyncSetting,$lineItem);
                    }
                }elseif($lineItem['line_item_type'] == 'Shipping'){
                    $product_name_to_match = $tallySyncSetting['shipping_product_name'];
                }
                $product = Tallyproduct::where('sku',$product_name_to_match)->first();
                if(empty($product)){
                    $lineItemData[] = $product_name_to_match;
                }
            }
            
            if($sync == 'refund'){
                $type = 'CN';
            }else{
                if($order['total_amount'] >= 0){
                    $type = 'Inv';
                } else {
                    $type = 'CN';
                }
            }
            $setVoucherType = $this->setVoucherType($tallySyncSetting, $order, $type);
            
            $accountMapping = array();
            /*$order['tally_id'] = array();
            $order['sync_flag'] = 'N';*/
            if(empty($order['tally_id']) && $order['sync_flag'] == "N" && !empty($lineItemData)){
                $data = $this->checkItemExitsQueue($tallyConnected,$order, 'Sales',$tallySyncSetting);
                
            }else{
                if($order['sync_flag'] == "PS"){
                    $receiptRequest = new \Illuminate\Http\Request();
                    $receiptRequest->replace(['seller_id' => $order['seller_id'],'order_id'=>$order['id']]);
                    $receiptController = new ReceiptController();
                    $receiptController->createReceipt($receiptRequest);

                }elseif(empty($lineItemData) && ($order['sync_flag'] != "INV" && $order['sync_flag'] != "CN") ){
                    TallyOrders::where('id',$order['id'])->where('module', $order['module'])->where('seller_id', $order['seller_id'])->update(['sync_flag' => "ORCH"]);
                    /*Put order check queue*/
                    $orderObj = new InvoiceController();
                    $orderObj->checkOrderExitsQueue($order['id']);

                }elseif($order['sync_flag'] == "INV" || $order['sync_flag'] == "CN"){
                    
                    $totalLineAmount = $taxLineAmount = 0;
                    $lineItem = [];
                    foreach($order['line_items'] as $key =>  $value){

                        if(empty($value['quantity'])){
                            continue; //If quantity is 0 then do not create that line item. in update order quantity was tally so handled that situation. NS: 06-05-2022
                        }
                        if (isset($value['tax_amount']) && $tallySyncSetting['tax_method'] == 'line') { //Tax as line item
                            $taxLineAmount += (float)$value['tax_amount'];
                        }
                        $totalLineAmount += $value['unit_price'];
                        $lineItem[$key]['amount'] = number_format($value['unit_price'], 4, ".", "");
                        $lineItem[$key]['description'] = $value['sku'];
                        $lineItem[$key]['quantity'] = $value['quantity'];
                        $lineItem[$key]['rate'] = !empty($value['tax_rate'])?$value['tax_rate']:'';
                        if($value['line_item_type'] == "Product" || $value['line_item_type'] == "Order"){
                            $account = $tallySyncSetting['sales_account'];
                        }
                        $lineItem[$key]['account'] = $account;

                        if (!empty((float)$taxLineAmount) && $tallySyncSetting['tax_method'] == 'line') {

                            $taxLineKey = "Tax"; 
                            $key++;
                            $key++;
                            $azSeller = DB::connection('amz_tally')->table('az_seller')->where('id', $tallyConnected['seller_id'])->where('status', 'Active')->where('module',$tallyConnected['module'])->first();
                            if(isset($order['shipping_state'])){
                                if($order['shipping_state'] != $azSeller->state){

                                    $account = @$tallySyncSetting['tax_account'][floor($value['tax_rate'])]['IGST'];
                                    if($account == '')
                                    $account = @$tallySyncSetting['tax_account'][ceil($value['tax_rate'])]['IGST'];
                                    if(!isset($lineItem[$key]['quantity']))
                                    $lineItem[$key]['quantity'] = $value['quantity'];
                                    else
                                    $lineItem[$key]['quantity'] += $value['quantity'];
                                    if(!isset($lineItem[$key]['amount']))
                                    $lineItem[$key]['amount'] = number_format($value['tax_amount'], 4, ".", "");
                                    else
                                    $lineItem[$key]['amount'] += number_format($value['tax_amount'], 4, ".", "");
                                    $lineItem[$key]['rate'] = !empty($value['tax_rate'])?$value['tax_rate']:'';
                                    $lineItem[$key]['description'] = $taxLineKey;
                                    $lineItem[$key]['account'] = $account; //PENDING
                                    $totalLineAmount += $taxLineAmount;
                                }else{
                                    // dd($tallySyncSetting['tax_account']);
                                    $account = $tallySyncSetting['tax_account'][floor($value['tax_rate'])]['CGST'];
                                    if($account == '')
                                    $account = $tallySyncSetting['tax_account'][ceil($value['tax_rate'])]['CGST'];
                                    $accountOne = $tallySyncSetting['tax_account'][floor($value['tax_rate'])]['SGST'];
                                    if($accountOne == '')
                                    $accountOne = $tallySyncSetting['tax_account'][ceil($value['tax_rate'])]['SGST'];
                                    $lineItem[$key]['quantity'] = $value['quantity'];
                                    $lineItem[$key]['amount'] = number_format($value['tax_amount'], 4, ".", "") / 2;
                                    $lineItem[$key]['rate'] = !empty($value['tax_rate'])?$value['tax_rate'] / 2:'';
                                    $lineItem[$key]['description'] = $taxLineKey;
                                    $lineItem[$key]['account'] = $account; //PENDING
                                    $key = $key + 1;
                                    $lineItem[$key]['quantity'] = $value['quantity'];
                                    $lineItem[$key]['amount'] = number_format($value['tax_amount'], 4, ".", "") / 2 ;
                                    $lineItem[$key]['rate'] = !empty($value['tax_rate'])?$value['tax_rate'] / 2:'';
                                    $lineItem[$key]['description'] = $taxLineKey;
                                    $lineItem[$key]['account'] =  $accountOne; //PENDING
                                    $totalLineAmount += $taxLineAmount;
                                }
                            }
                        }
                        
                    }
                    
                    if($sync == 'refund'){
                        $dateInstance = date("Ym01", strtotime($order['refund_date']));
                        $order['order_number'] = $order['refund_id'];
                        $order['marketplace_order_id'] = $order['tally_order_id'];
                        $order['order_created_date'] = $order['refund_date'];
                        $order['tax_type'] = '';
                    }
                    else{
                        $dateInstance = date("Ym01", strtotime($order['order_created_date']));
                    }
                    
                    $journalArray = [
                        "REFERENCE" => $order['document_number'],
                        "NARRATION" => $order['document_number'],
                        "DATE" => $dateInstance,
                        "EFFECTIVEDATE" => $dateInstance,//CHANGE THIS VALUE NOW SET STATIC
                        "lineItem" => 
                            $lineItem
                        
                    ];
                    
                    $generatQueue = $this->createTallyQueue($tallyConnected, $tallySyncSetting, $journalArray, $order, $setVoucherType,$accountMapping,$sync);
                    
                }
            }
        }
        
        return array('code' => '200', 'message' => "Queue created successfully!");
    }

    public function createTallyQueue($tallyConnected, $tallySyncSetting, $journalArray, $orderData,$setVoucherType,$accountMapping,$sync)
    {
        $connectionDetails = TallyConnection::checkTallyConnection($tallyConnected['seller_id'], $tallyConnected['module']);
        if(!empty($connectionDetails)){
            // $ident="LedgerCreate-".$store_id."-".$connectionDetails->id;
            $shippingState = @$tallySyncSetting['customers'][ucwords(strtolower($orderData['shipping_state']))];

            $partyLadgerName = $shippingState;
            $journalItemArray = [];
            $i = 0;
            $LEDGERENTRIES[$i]['REMOVEZEROENTRIES'] = "No";
            $LEDGERENTRIES[$i]['ISDEEMEDPOSITIVE'] = "Yes";
            $LEDGERENTRIES[$i]['LEDGERFROMITEM'] = "No";
            $LEDGERENTRIES[$i]['LEDGERNAME'] = $partyLadgerName;
            $LEDGERENTRIES[$i]['AMOUNT'] = $orderData['total_amount'] * -1;
            $LEDGERENTRIES[$i]['BILLALLOCATIONS.LIST']['NAME'] = $orderData['document_number'];
            $LEDGERENTRIES[$i]['BILLALLOCATIONS.LIST']['BILLTYPE'] = 'New Ref';
            $LEDGERENTRIES[$i]['BILLALLOCATIONS.LIST']['AMOUNT'] = $orderData['total_amount'] * -1;

            // $LEDGERENTRIES = [];
            
            foreach($journalArray['lineItem'] as $key => $journalValue){ //SET ALLLEDGERENTRIES.LIST ARRAY
                // $journalItemArray[$key]['LEDGERNAME'] = $journalValue['account'];
                if($journalValue['description'] != "Tax"){
                    $journalItemArray[$key]['STOCKITEMNAME'] = $journalValue['description'];
                    $journalItemArray[$key]['ACTUALQTY'] = $journalValue['quantity'];
                    $journalItemArray[$key]['BILLEDQTY'] = $journalValue['quantity'];
                    $journalItemArray[$key]['ISDEEMEDPOSITIVE'] = "No";
                    $journalItemArray[$key]['RATE'] = $journalValue['amount'];
                    $journalItemArray[$key]['AMOUNT'] = $journalValue['amount'];
                    $journalItemArray[$key]['ACCOUNTINGALLOCATIONS.LIST']['REMOVEZEROENTRIES'] = "No";
                    $journalItemArray[$key]['ACCOUNTINGALLOCATIONS.LIST']['ISDEEMEDPOSITIVE'] = "No";
                    $journalItemArray[$key]['ACCOUNTINGALLOCATIONS.LIST']['LEDGERFROMITEM'] = "No";
                    $journalItemArray[$key]['ACCOUNTINGALLOCATIONS.LIST']['TAXCLASSIFICATIONNAME'] = "";
                    $journalItemArray[$key]['ACCOUNTINGALLOCATIONS.LIST']['LEDGERNAME'] = $journalValue['account'];
                    $journalItemArray[$key]['ACCOUNTINGALLOCATIONS.LIST']['AMOUNT'] = $journalValue['amount'];
                }else{
                    $i++;
                    $LEDGERENTRIES[$i]['REMOVEZEROENTRIES'] = "No";
                    $LEDGERENTRIES[$i]['ISDEEMEDPOSITIVE'] = "No";
                    $LEDGERENTRIES[$i]['LEDGERFROMITEM'] = "No";
                    $LEDGERENTRIES[$i]['LEDGERNAME'] = $journalValue['account'];
                    $LEDGERENTRIES[$i]['AMOUNT'] = $journalValue['amount'];
                }
            }
            if(!empty($orderData['tally_id'])){
                $attributeArray = [
                        "DATE" => $journalArray['DATE'],
                        "TAGNAME" => "MASTER ID",
                        "TAGVALUE" => $orderData['tally_id'],
                        "VCHTYPE" => strtoupper($setVoucherType),//SET VOUCHER TYPE (SALES, CREADIT NOTE, JOURNAL) GET BY FUNCTION
                        "ACTION" => "Alter",
                ];
                $vaoucherTypeAction = "Update";
            }else{
                $attributeArray = [
                    "VCHTYPE" => strtoupper($setVoucherType),//SET VOUCHER TYPE (SALES, CREADIT NOTE, JOURNAL) GET BY FUNCTION
                    "ACTION" => "Create",
                ];
            }
                $vaoucherTypeAction = "Create";
            $replaceVoucherType = "SalesInvoice".$vaoucherTypeAction;
            $ident = $replaceVoucherType."-".$tallyConnected['seller_id'].'-'.$orderData['id'];

            list($reqDataAry,$extraData) = $this->createJournalIndividualXml($connectionDetails,$attributeArray,$setVoucherType,$journalArray,$journalItemArray,$orderData,$accountMapping,$LEDGERENTRIES,$sync);
            

            $response = $this->tallyApi($connectionDetails,$ident,$replaceVoucherType,$reqDataAry,$extraData);

            if(!empty($response->success)){
                // Tallysummary::updateSummaryStatus($extraData, "OJV");
                $data['success'] = true;
                $data['message'] = (isset($response->message))?$response->message:$response;
            }
            $data = $this->handleResponse($response);
        }else{
            $data['success'] = false;
            $data['message'] = "Tally not connected for this store";
            $code= 401;
        }
        return $data;
    }

    //CHECK BY REFERENCE WISE LEDGER IS EXITS IN TALLY OR NOT QUEUE
    public function checkItemExitsQueue($tallyConnected, $orderData, $setVoucherType,$tallySyncSetting)
    {
        $data = [];
        $connectionDetails = TallyConnection::checkTallyConnection($tallyConnected['seller_id'], $tallyConnected['module']);
        if(!empty($connectionDetails)){
            $ident = "ItemCollection-".$tallyConnected['seller_id'].'-'.$orderData['id'];
            $sku = [];
            foreach($orderData['line_items'] as $key => $lineItem){

                $product_name_to_match = $this->getProductNametoMatch($tallySyncSetting,$lineItem);

                $product = Tallyproduct::where('sku',$product_name_to_match)->first();
                $product = array();
                if(empty($product)){
                    $lineItemData[] = $product_name_to_match;
                    if($key == 0){
                        $firstName = '"'.$product_name_to_match;
                    }else {
                        $sku[] = ' OR $NAME Equal "'.$product_name_to_match.'"';
                    }
                }
            }

            $newName = implode('',$sku);
            if(!empty($newName) || !empty($firstName)){
               
                list($reqDataArry,$extraData) = $this->getItemXml($connectionDetails,$orderData,$lineItemData,$firstName,$newName,'specific');

                $response = $this->tallyApi($connectionDetails,$ident,"ItemCollection",$reqDataArry,$extraData);
                if(!empty($response->success)){
                    TallyOrders::where('id',$orderData['id'])->where('module', $orderData['module'])->where('seller_id', $orderData['seller_id'])->update(['sync_flag' => "P"]);
                }
                $data = $this->handleResponse($response);
            }
        } else{
            $data['success'] = false;
            $data['message'] = "Tally not connected for this store";
            $code= 401;
        }
        return $data;
    }
        
    public function checkOrderExitsQueue($order_id)
    {
        $orderData = TallyOrders::where('id',$order_id)->first();
        
        if($orderData['total_amount'] >= 0){
            $type = 'Inv';
        } else {
            $type = 'CN';
        }
        list($tallyConnected, $tallySyncSetting) = $this->getSettings($orderData['seller_id']);
        $setVoucherType = $this->setVoucherType($tallySyncSetting, $orderData, $type);
        
        $attributeArray = [
                "NAME" => "Voucher Collection",
                "ISMODIFY" => "No",
                "ISFIXED" => "No",
                "ISINITIALIZE" => "No",
                "ISOPTION" => "No",
                "ISINTERNAL" => "No"
        ];
        $vaoucherTypeAction = "Collection";
        
        $replaceVoucherType = 'Voucher'.$vaoucherTypeAction;
        $ident = $replaceVoucherType."-".$tallyConnected['seller_id'].'-'.$orderData['id'];
        $connectionDetails = TallyConnection::checkTallyConnection($tallyConnected['seller_id'], $tallyConnected['module']);
        if(!empty($connectionDetails)){
            list($reqDataArry,$extraData) = $this->getInvoiceXml($connectionDetails,$attributeArray,$setVoucherType,$orderData);

            $response = $this->tallyApi($connectionDetails,$ident,$replaceVoucherType,$reqDataArry,$extraData);
        }
        
    }
}
