<?php

namespace App\Http\Controllers\Individual;
use App\Models\Apierrorlog;
use Illuminate\Http\Request;
use App\Models\TallyConnection;
use App\Models\Tallycronongoing;
use App\Models\Tallypayouts;
use App\Http\Traits\Journal;
use App\Http\Traits\Requestresponse;
use App\Http\Controllers\Controller;

class JournalvoucherController extends Controller
{
    use Journal;
    use Requestresponse;
    protected $bulkDataObjDetail = array();
    protected $commonControllerObj = array();

    public function createJournalVoucher(Request $request)
    {
        $seller_id = $request->seller_id;

        list($tallyConnected, $tallySyncSetting) = $this->getSettings($seller_id);
        //dd($tallySyncSetting);
        if (!empty($tallyConnected) && !empty($tallySyncSetting)) {
            $syncOrder = array('code' => '200', 'message' => "No record found to sync!");
            //$cronOngoingCheck = Tallycronongoing::checkCronOnGoing($tallyConnected['seller_id'], $tallyConnected['module']);
            
            if (!empty($cronOngoingCheck)) {
                return array('code' => '409', 'message' => 'Currently process is going on your store, please try after some time.');
            }
            
            if (empty($request->get('order_number'))) {
                //For individual order sync we will not create entry.
                Tallycronongoing::createCronOnGoing($tallyConnected['seller_id'], $tallyConnected['module'], ucfirst($tallyConnected['marketplace']) . '_Create_Summary_Invoice_DB_to_TALLY');
            }
            $dbPayouts = Tallypayouts::fetchUnsyncPayouts($tallyConnected, $request, 'create');

            if((empty($request->get('status')) || strtolower($request->get('status')) == 'sync') && empty($request->get('order_number')))
                $dbPayoutsUpdate = Tallypayouts::fetchUnsyncPayouts($tallyConnected, $request, 'update', array_column($dbPayouts, 'id'));
            else
                $dbPayoutsUpdate = array();

            $dbPayouts = array_merge($dbPayouts, $dbPayoutsUpdate);
     
            if (!empty($dbPayouts)) {
                $syncPayout = $this->syncOrderData($tallyConnected, $tallySyncSetting, $dbPayouts,'payout');
            }
            
            //Delete cron on going
            Tallycronongoing::deleteCronOnGoing($tallyConnected['seller_id'], $tallyConnected['module']);
            
            return $syncPayout; 
        
        } else if (empty($tallyConnected)) {
            return array('code' => '408', 'message' => 'Invalid Seller!');
        } else if (empty($tallySyncSetting)) {
            return array('code' => '408', 'message' => "Seller's Settings not found!");
        }
    }

    public function syncOrderData($tallyConnected, $tallySyncSetting, $dbPayouts,$sync = 'order')
    {
        foreach ($dbPayouts as  $payout) {
            $type = 'JOURNAL';
            $setVoucherType = $this->setVoucherType($tallySyncSetting, $payout, $type);
            $payout['document_number'] = $payout['payout_id'];
            $accountMapping = array();
            $payout['sync_status'] = 'New1';
            if(empty($payout['tally_id']) && $payout['sync_status'] == "New"){
                $data = $this->checkJournalExitsQueue($tallyConnected,$payout, 'Sales');
            }else{
                $totalLineAmount = $taxLineAmount = 0;
                
                $dateInstance = date("Ym01", strtotime($payout['payout_date']));

                $journalArray = [
                    "REFERENCE" => $payout['payout_id'],
                    "NARRATION" => $payout['payout_id'],
                    "DATE" => $dateInstance,
                    "EFFECTIVEDATE" => $dateInstance,//CHANGE THIS VALUE NOW SET STATIC
                    "payout_data" => 
                        $payout
                    
                ];
                
                $generatQueue = $this->createTallyQueue($tallyConnected, $tallySyncSetting, $journalArray, $payout, $setVoucherType,$accountMapping,$sync);
            }
        }
        
        return array('code' => '200', 'message' => "Queue created successfully!");
    }

    public function createTallyQueue($tallyConnected, $tallySyncSetting, $journalArray, $payoutData,$setVoucherType,$accountMapping,$sync)
    {
        $connectionDetails = TallyConnection::checkTallyConnection($tallyConnected['seller_id'], $tallyConnected['module']);
        if(!empty($connectionDetails)){
            
            $i = 0;
            $LEDGERENTRIES[$i]['LEDGERNAME'] = $tallySyncSetting['holding_account'];
            $LEDGERENTRIES[$i]['ISDEEMEDPOSITIVE'] = "Yes";
            $LEDGERENTRIES[$i]['AMOUNT'] = $payoutData['amount'] * -1;
            $i++;   
            $LEDGERENTRIES[$i]['LEDGERNAME'] = $tallySyncSetting['bank_account'];
            $LEDGERENTRIES[$i]['ISDEEMEDPOSITIVE'] = "No";
            $LEDGERENTRIES[$i]['AMOUNT'] = $payoutData['amount'];
            
            if(!empty($payoutData['tally_id'])){
                $attributeArray = [
                        "DATE" => $journalArray['DATE'],
                        "TAGNAME" => "MASTER ID",
                        "TAGVALUE" => $payoutData['tally_id'],
                        "VCHTYPE" => strtoupper($setVoucherType),
                        "ACTION" => "Alter",
                ];
                $vaoucherTypeAction = "Update";
            }else{
                $attributeArray = [
                    "VCHTYPE" => strtoupper($setVoucherType),
                    "ACTION" => "Create",
                ];
                $vaoucherTypeAction = "Create";
            }
            $replaceVoucherType = "Journal".$vaoucherTypeAction;
            $ident = $replaceVoucherType."-".$tallyConnected['seller_id'].'-'.$payoutData['id'];

            $payoutData['marketplace_primary_id'] = $payoutData['marketplace_payout_id'];
            $payoutData['marketplace_record_type'] = 'payout';
            //$payoutData['document_number']
            $payoutData['invoice_date'] = $payoutData['payout_date'];
            $payoutData['total_amount'] = $payoutData['amount'];
            $payoutData['json_amount'] = 0;
            $payoutData['tax_type'] = '';


            list($reqDataAry,$extraData) = $this->createJournalSummaryXml($connectionDetails,$attributeArray,$setVoucherType,$journalArray,$LEDGERENTRIES,$payoutData,'journal');
            $response = $this->tallyApi($connectionDetails,$ident,$replaceVoucherType,$reqDataAry,$extraData);
                

            if(!empty($response->success)){
                // Tallysummary::updateSummaryStatus($extraData, "OJV");
                $data['success'] = true;
                $data['message'] = (isset($response->message))?$response->message:$response;
            }
            $data = $this->handleResponse($response);
        }else{
            $data['success'] = false;
            $data['message'] = "Tally not connected for this store";
            $code= 401;
        }
        return $data;
    }

    //CHECK BY REFERENCE WISE LEDGER IS EXITS IN TALLY OR NOT QUEUE
    public function checkJournalExitsQueue($tallyConnected, $summaryData, $setVoucherType)
    {
        $connectionDetails = TallyConnection::checkTallyConnection($tallyConnected['seller_id'], $tallyConnected['module']);
        if(!empty($connectionDetails)){
            $ident = "VoucherCollection-".$tallyConnected['seller_id'].'-'.$summaryData['id'];
            
            list($reqDataArry,$extraData) = $this->getJournalSummaryXml($connectionDetails,$summaryData,$setVoucherType);

            $response = $this->tallyApi($connectionDetails,$ident,"VoucherCollection",$reqDataArry,$extraData);
            if(!empty($response->success)){
                Tallypayouts::updatePayoutStatus($extraData, "ORCHECK");
            }
            $data = $this->handleResponse($response);
        } else{
            $data['success'] = false;
            $data['message'] = "Tally not connected for this store";
            $code= 401;
        }
        return $data;
    }
    
    public function amountMisMatchMail($sellerDetails){
        $content = view('mail', ['seller'=> $sellerDetails]); // $this->load->view('email', '', true);

        $maildata['email_to'] = 'sanjay@parextech.com';
        $maildata['email_to_name'] = 'Sanjay Patel';
        $maildata['email_from'] = 'apps@parextech.com';
        $maildata['email_from_name'] = 'Parex Bridge Support';
        $maildata['subject'] = 'Summary sync stop due to amount mismatch';
        $maildata['body'] = (string)$content;
        $maildata['text'] = 'Thank you for using QB Bridge';
        $maildata['tag'] = 'QuickBooks Bridge Support';
        $maildata['reply_to'] = 'apps@parextech.com';
        $maildata['cc'] = '';
        
        // $mailResponse = Helper::sendmail($maildata['email_to'],$maildata['email_to_name'],$maildata['email_from'],$maildata['email_from_name'],$maildata['subject'],$maildata['body'],$maildata['text'],$maildata['tag'],$maildata['reply_to'],$maildata['cc']);
        // Maillog::saveMailLog($maildata,$mailResponse);
        
    }
}
