<?php

namespace App\Http\Controllers\Individual;

use App\Http\Controllers\Controller;
use App\Helpers\Helper;
use App\Models\Apierrorlog;
use Illuminate\Http\Request;
use App\Models\TallyConnection;
use App\Models\Tallycronongoing;
use App\Models\Tallypayments;
use App\Models\TallyOrders;
use App\Http\Traits\Receipt;
use App\Http\Traits\Requestresponse;
use DB;
use Log;

class ReceiptController extends Controller
{
    use Receipt;
    use Requestresponse;
    protected $bulkDataObjDetail = array();
    protected $commonControllerObj = array();

    public function createReceipt(Request $request)
    {
        $seller_id = $request->seller_id;

        list($tallyConnected, $tallySyncSetting) = $this->getSettings($seller_id);
        if (!empty($tallyConnected) && !empty($tallySyncSetting)) {
            $syncReceipt = array('code' => '200', 'message' => "No record found to sync!");
            
            if (!empty($cronOngoingCheck)) {
                return array('code' => '409', 'message' => 'Currently process is going on your store, please try after some time.');
            }
            if($request->get('order_id') != ''){
                $dbReceipts = Tallypayments::getPaymentsByOrderId($tallyConnected['seller_id'], $tallyConnected['module'],$request->get('order_id'));
            }else{
                $dbReceipts = Tallypayments::fetchUnsyncReceipt($tallyConnected, $request, 'create');
            }

            if (!empty($dbReceipts)) {
                $syncReceipt = $this->syncReceiptData($tallyConnected, $tallySyncSetting, $dbReceipts);
            }

            //Delete cron on going
            Tallycronongoing::deleteCronOnGoing($tallyConnected['seller_id'], $tallyConnected['module']);
            
            return $syncReceipt; 
        
        } else if (empty($tallyConnected)) {
            return array('code' => '408', 'message' => 'Invalid Seller!');
        } else if (empty($tallySyncSetting)) {
            return array('code' => '408', 'message' => "Seller's Settings not found!");
        }
    }

    public function syncReceiptData($tallyConnected, $tallySyncSetting, $dbReceipts)
    {
        foreach ($dbReceipts as  $receipt) {

            $accountMapping = array();
            if(empty($receipt['tally_id']) && $receipt['sync_flag'] == "N" && !empty($lineItemData)){
                $data = $this->checkItemExitsQueue($tallyConnected,$receipt, 'Sales');
            }else{
                $dateInstance = date("Ym01", strtotime($receipt['payment_date']));
                $ALLLEDGERENTRIES = array();
                $receiptArray = [
                    "REFERENCE" => $receipt['tally_order_id'],
                    "NARRATION" => $receipt['tally_order_id'],
                    "DATE" => $dateInstance,
                    "EFFECTIVEDATE" => $dateInstance,
                    "PARTYLEDGERNAME" => 'Consumer Gujarat',
                    'receipt_data' => $receipt
                ];
                $sync = 'order';
                $generatQueue = $this->createTallyQueue($tallyConnected, $tallySyncSetting, $receiptArray, $receipt, $sync);
            }
        }
        
        return array('code' => '200', 'message' => "Queue created successfully!");
    }

    public function createTallyQueue($tallyConnected, $tallySyncSetting, $receiptArray, $receiptData, $sync)
    {
        $connectionDetails = TallyConnection::checkTallyConnection($tallyConnected['seller_id'], $tallyConnected['module']);
        if(!empty($connectionDetails)){

            $orderData = TallyOrders::where('id',$receiptData['tally_order_id'])->first();
            $shippingState = @$tallySyncSetting['customers'][ucfirst(strtolower($orderData['shipping_state']))];

            $partyLadgerName = $shippingState;

            $i = 0;
            $LEDGERENTRIES[$i]['REMOVEZEROENTRIES'] = "No";
            $LEDGERENTRIES[$i]['ISDEEMEDPOSITIVE'] = "No";
            $LEDGERENTRIES[$i]['LEDGERFROMITEM'] = "No";
            $LEDGERENTRIES[$i]['LEDGERNAME'] = $partyLadgerName;
            $LEDGERENTRIES[$i]['AMOUNT'] = $receiptData['total_amount'];
            $LEDGERENTRIES[$i]['BILLALLOCATIONS.LIST']['NAME'] = $orderData['document_number'];
            $LEDGERENTRIES[$i]['BILLALLOCATIONS.LIST']['BILLTYPE'] = 'Agst Ref';
            $LEDGERENTRIES[$i]['BILLALLOCATIONS.LIST']['AMOUNT'] = $receiptData['total_amount'];
            
            $i++;
            $LEDGERENTRIES[$i]['REMOVEZEROENTRIES'] = "No";
            $LEDGERENTRIES[$i]['ISDEEMEDPOSITIVE'] = "No";
            $LEDGERENTRIES[$i]['LEDGERFROMITEM'] = "No";
            $LEDGERENTRIES[$i]['LEDGERNAME'] = $tallySyncSetting['bank_account'];
            $LEDGERENTRIES[$i]['AMOUNT'] = $receiptData['total_amount'] * -1;

            if(!empty($receiptData['tally_id'])){
                $attributeArray = [
                        "DATE" => $receiptArray['DATE'],
                        "TAGNAME" => "MASTER ID",
                        "TAGVALUE" => $receiptData['tally_id'],
                        "VCHTYPE" => strtoupper('receipt'),
                        "ACTION" => "Alter",
                ];
                $vaoucherTypeAction = "Update";
            }else{
                $attributeArray = [
                    "VCHTYPE" => strtoupper('receipt'),
                    "ACTION" => "Create",
                ];
                $vaoucherTypeAction = "Create";
            }
            $replaceVoucherType = "Receipt".$vaoucherTypeAction;
            $ident = $replaceVoucherType."-".$tallyConnected['seller_id'].'-'.$receiptData['id'];

            list($reqDataAry,$extraData) = $this->createReceiptXml($connectionDetails,$attributeArray,$receiptArray,$receiptData,$LEDGERENTRIES,$sync);
            
            $response = $this->tallyApi($connectionDetails,$ident,$replaceVoucherType,$reqDataAry,$extraData);

            if(!empty($response->success)){
                $data['success'] = true;
                $data['message'] = (isset($response->message))?$response->message:$response;
            }
            $data = $this->handleResponse($response);
        }else{
            $data['success'] = false;
            $data['message'] = "Tally not connected for this store";
            $code= 401;
        }
        return $data;
    }
}
