<?php
namespace App\Http\Traits;
use App\Helpers\Helper;
use App\Models\Apierrorlog;
use Log;

/*
Manali Patel - 15-09-2023
This trait is used to handle request and response format.
*/
trait Requestresponse
{
    public function generateRequestArray($account,$connectionDetails, $ledgerArray)
    {
        $reqDataAry = [
            "HEADER" => [
                "VERSION" => "1",
                "TALLYREQUEST" => "IMPORT",
                "TYPE" => "DATA",
                "ID" => "ALL MASTERS",
            ],
            "BODY" => [
                "DESC" => [
                    "STATICVARIABLES" => ["SVCURRENTCOMPANY" => $connectionDetails->company_name],
                    "DATA" => [
                        "TALLYMESSAGE" => [
                            "LEDGER" => $ledgerArray
                            ],
                        ],
                    ],
                ],
        ];
        Log::info('request tally : '.print_r($reqDataAry,1));
        return  $reqDataAry;
    }

    public function handleResponse($response){
        $data=[];
        Log::info('request response : '.print_r($response,1));
        if(!is_null($response)){
            if($response->success){
                $data['success'] = true;
                $data['message'] = $response->message;
            }else{

                $actionlog = array(
                    'error_code' => '400',
                    'error_msg'  => $response->message,
                    'uniqueId'   => '',
                    'data'       => $response,
                    'seller_id'  => $seller_id,
                    'module'     => $request->module
                );
                Apierrorlog::addErrorlog($actionlog);
                $data['success'] = false;
                $data['message'] = $response->message;
            }
        }else{
            $data['success'] = false;
            $data['message'] = 'Null response received.';
        }
        return $data;
    }
    public static function xmlRequest($action,$mode,$ident,$requestData,$extraData)
    {
       
        $reqAry = [
            "mode" => $mode,
            "action" => $action,
            "ident" => $ident,
            "requestData" => $requestData,
            "extraData" =>$extraData,
        ];
        return json_encode( $reqAry);
    }
}

