<?php
namespace App\Http\Traits;
use App\Helpers\Helper;
use Log;

/*
Manali Patel - 15-09-2023
This trait is used to form xml requests to create and fetch tax.
*/
trait Tax
{
    public function createTaxAccountExtraData($connectionDetails,$account){
        $extraData = [
                "seller_id" => $connectionDetails->seller_id,
                "module" => $connectionDetails->module,
                "company" => $connectionDetails->company_name,
                "name" => $account['name'],
                "parent" => $account['parent'],
                "gst_duty" => @$account['gst_duty'],
                "type_of_supply" => @$account['type_of_supply'],
                "round_method" => @$account['round_method'],
                "category" => @$account['category'],
                "rate_of_tax_calculation" => @$account['rate_of_tax_calculation']
            ];
            return $extraData;
    }

    public function createTaxAccountXml($account){
        $ledgerArray = [
            "@attributes" => [
                "ACTION" => "CREATE"
            ],
            "NAME" => $account['name'],
            "PARENT" => $account['parent'],
            "TAXTYPE" => isset($account['taxtype']) ? $account['taxtype'] : '',
            "GSTDUTYHEAD" => $account['gst_duty'],
            "GSTTYPEOFSUPPLY" => $account['type_of_supply'],
            "ROUNDINGMETHOD" => $account['round_method'],
            "SERVICECATEGORY" => $account['category'],
            "RATEOFTAXCALCULATION" => $account['rate_of_tax_calculation'],//$account['parent'],
            // "COUNTRYOFRESIDENCE" => $account['parent'],//$account['rate_of_tax_calculation'],
        ];
        $extraData = $this->createTaxAccountExtraData($connectionDetails);
        return array($reqDataAry,$extraData);
    }
}
