<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Accounts extends Model
{
    use HasFactory;
    protected $connection             = 'tally';
    protected $dates                  = [''];
    protected $table                  = 'tally_accounts';
    protected $rules                  = array();
    protected $injectUniqueIdentifier = true;
    protected $fillable = ['name','country','state','tax_type','seller_id','module','parent','ledger_guid'];
    
    // public static function UpdateAccountData($name, $country, $seller_id, $state, $tax_type, $module, $parent)
    public static function UpdateAccountData($name, $seller_id, $module, $data)
    {
        Accounts::updateOrCreate([
            //Add unique field combo to match here
            //For example, perhaps you only want one entry per user:
            'name'   => $name,
            'seller_id' => $seller_id,
            'module' => $module
        ],
        // [
        //     'name'=> $name,
        //     'parent'=> $parent,
        //     'country'=> $country,
        //     'state' => $state,
        //     'tax_type'=> $tax_type,
        //     'seller_id' => $seller_id,
        //     'module' => $module
        // ]
        $data
        );
    }

    public static function deleteAllAccounts($seller_id, $module)
    {
        Accounts::Where('seller_id',$seller_id)->where('module',$module)->delete();
    }

    public static function createAccountData($name, $country, $seller_id, $state, $tax_type, $parent, $GUID, $module)
    {
        Accounts::Create([
            'name'=> $name,
            'parent' => $parent,
            'ledger_guid' => $GUID,
            'country'=> $country,
            'state' => $state,
            'tax_type'=> $tax_type,
            'seller_id' => $seller_id,
            'module' => $module
        ]);
    }

}
