<?php
namespace App\Models;

use App\Models\Loggable;
use App\Models\ParexModel;
use App\Helpers\Helper;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
// use Watson\Validating\ValidatingTrait;
use App\Models\Master\Plans;
use App\Models\Master\User;
use Auth;
use DB;

class Sellers extends Model
{
  protected $connection = 'mysql';
    // use Loggable;
    use SoftDeletes;
   // use SoftDeletes;

    protected $dates = ['deleted_at'];
    protected $table = 'sellers';


    protected $rules = array(
    );

    protected $injectUniqueIdentifier = true;
    // use ValidatingTrait;

 	protected $fillable = ['seller_name', 'status'];

   public static function Getsubidwithcustoid($seller_id='')
   {
      $sellerdetails = Sellers::select('seller_plan.id','sellers.id as seller_id','seller_plan.subscriptions_id','az_users.stripe_customer_id','plans.plan_type','plans.gateway_name')
      ->leftjoin('user_seller_int','user_seller_int.seller_id','=','sellers.id')
      ->leftjoin('seller_plan','seller_plan.seller_id','=','sellers.id')
      ->leftjoin('plans','seller_plan.plan_id','=','plans.id')
                    ->leftjoin('az_users','az_users.id','=','user_seller_int.user_id')
                    ->whereNull('seller_plan.deleted_at')
                    ->where('seller_plan.status','Active')
                    ->where('sellers.id',$seller_id)->first();
      return $sellerdetails;
   }
 	public function scopeTextSearch($query, $search)
    {

        return $query->where(function ($query) use ($search) {
        
            $query->where('seller_name', 'LIKE', '%'.$search.'%');
        });
    }
     /**
     update and add billing start day
        HR - 2019
    */
    public static function UpdateBillingdate($subscriptions,$plan_id)
    {
      $seller_plan = SellerPlan::where('seller_id',$subscriptions['seller_id'])->first();
      $plans = Plans::where('id',$plan_id)->first();

      $Sellers = Sellers::find($subscriptions['seller_id']);
      if($seller_plan)
      {   
        //$seller_plan = $seller_plan->plan_activated_on;
        $date =date('Y-m-d');
        $date1=date_create($seller_plan->plan_activated_on);
        $date2=date_create($date);
        $diff=date_diff($date1,$date2);
        if($plans->trial_days >= 1){
        $date = $plans->trial_days - $diff->format("%a");
        if($date <= $plans->trial_days){
          $Sellers->billing_start_date  = date("Y-m-d",strtotime("+".$date." day"));
        }else{
          $Sellers->billing_start_date  = date("Y-m-d");
        }
       }
        
      }else{
        
            if($plans->trial_days >= 1){
          $Sellers->billing_start_date = date( "Y-m-d", strtotime( "+".$plans->trial_days." day" ) );
        }else{
          $Sellers->billing_start_date  = date("Y-m-d");
        }
      }
      $Sellers->payment_status = 'Paid';
      $Sellers->save();
      return $Sellers;

    }
     /**
     check seller purchase plan
        HR - 2019
    */
    public static function checkplanpurchase($seller_id='')
    {
       $sellerplan =  Sellers::select('sellers.id','sellers.seller_name','sellers.az_app_token','sellers.az_seller_id','s_p.plan_name','s_p.plan_price','s_p.id as s_p_id','s_p.plan_cancelled_on','sellers.marketplace_name')
            ->join('user_seller_int','user_seller_int.seller_id','=','sellers.id')
            ->join("seller_plan as s_p",'s_p.seller_id','=','sellers.id')
            ->Where('sellers.id',$seller_id)
            ->whereNull ('s_p.plan_cancelled_on')
            ->where('user_seller_int.user_id',Auth::user()->id)->first();

            return $sellerplan;
    }

     /**
     get seller wise seller details
        HR - 2019
    */
    public static function getSellerDetails($seller_id='')
    {
      $sellerdetails = Sellers::select('sellers.id','sellers.seller_name','sellers.az_app_token','sellers.az_seller_id','seller_marketplace_id.az_marketplace_id','seller_marketplace_id.id as seller_marketplace_id','sync_settings.*','seller_marketplace_id.az_marketplace_name')
      ->join('qbo_credential','qbo_credential.seller_id','=','sellers.id')
      ->join('sync_settings','sync_settings.seller_id','=','sellers.id')
      ->join('seller_marketplace_id','seller_marketplace_id.seller_id','=','sellers.id')
      ->where('seller_marketplace_id.status','Active')      
      ->where('sync_settings.status','Active')
      ->where('sellers.id',$seller_id)->get();
      
      return $sellerdetails;
   }

   public static function getAutoSellerDetails(){
      $sellerdetails = Sellers::select('sellers.id as sellerId','sellers.seller_name','sellers.az_app_token','sellers.az_seller_id','seller_marketplace_id.az_marketplace_id','seller_marketplace_id.id as seller_marketplace_id','sync_settings.*')
      ->join('qbo_credential','qbo_credential.seller_id','=','sellers.id')
      ->join('sync_settings','sync_settings.seller_id','=','sellers.id')
      ->join('seller_marketplace_id','seller_marketplace_id.seller_id','=','sellers.id')
      ->join('seller_plan','seller_plan.seller_id','=','sellers.id')
      ->where('sellers.status','Active')
      ->where('qbo_credential.status','Active')
      ->where('seller_plan.status','Active')
      ->where('sync_settings.autosync_enable','Y')
      ->where('seller_marketplace_id.status','Active')
      ->whereNull('seller_plan.deleted_at')->groupBy('sellers.az_seller_id')->get();
      
      return $sellerdetails;  
   }

   // public static function getSellerDetailsById($seller_id='')
   //  {
   //    $sellerdetails = Sellers::select('sellers.id','sellers.seller_name','sellers.az_app_token','sellers.az_seller_id','seller_marketplace_id.az_marketplace_id','seller_marketplace_id.id as seller_marketplace_id','seller_marketplace_id.country','seller_marketplace_id.currency','sync_settings.*','seller_plan.plan_type','seller_marketplace_id.az_marketplace_name')
   //    ->join('qbo_credential','qbo_credential.seller_id','=','sellers.id')
   //    ->join('sync_settings','sync_settings.seller_id','=','sellers.id')
   //    ->join('seller_marketplace_id','seller_marketplace_id.seller_id','=','sellers.id')
   //    ->join('seller_plan','seller_plan.seller_id','=','sellers.id')
   //    ->where('seller_marketplace_id.status','Active')
   //    ->where('seller_plan.status','Active')
   //    //->where('seller_marketplace_id.currency','USD')
   //    ->where('sellers.id',$seller_id)->whereNull('seller_plan.deleted_at')->get();
      
   //    return $sellerdetails;
   // }
   /**
     list of seller for view seller list
        HR - 2019
    */
   public static function ListSellers()
   {
          $user_id= Auth::user()->id;
         $Sellers = DB::select( DB::raw("SELECT `sellers`.`id`, `sellers`.`seller_name`, `sellers`.`az_app_token`, `sellers`.`az_seller_id`, `T2`.`plan_name`, `T2`.`plan_price`, `T2`.`id` as `T2_id`, `T2`.`plan_cancelled_on`,`T2`.`max_orders_allowed`,`T2`.`dollar_per_order`,`sellers`.`marketplace_name` FROM sellers inner join `user_seller_int` on `user_seller_int`.`seller_id` = `sellers`.`id` LEFT JOIN (SELECT seller_id, MAX(id) AS maxid FROM seller_plan GROUP BY seller_id) AS T1 ON sellers.id = T1.seller_id LEFT JOIN seller_plan AS T2 ON T2.id = T1.maxid where `user_seller_int`.`user_id` = '$user_id' and `sellers`.`status` = 'Active' and  `sellers`.`deleted_at` is null group by sellers.id  order by `sellers`.`created_at` desc ") );
         //$Sellers = DB::select( DB::raw("select `sellers`.`id`, `sellers`.`seller_name`, `sellers`.`az_app_token`, `sellers`.`az_seller_id`, `s_p`.`plan_name`, `s_p`.`plan_price`, `s_p`.`id` as `s_p_id`, `s_p`.`plan_cancelled_on`,`s_p`.`max_orders_allowed`,`s_p`.`dollar_per_order` from `sellers` inner join `user_seller_int` on `user_seller_int`.`seller_id` = `sellers`.`id` LEFT join `seller_plan` as s_p on `s_p`.`seller_id` = `sellers`.`id` where `user_seller_int`.`user_id` = '$user_id' and  (`sellers`.`deleted_at` is null or s_p.id in (SELECT max(id) FROM `seller_plan` group by `seller_plan`.`seller_id`)  ) group by sellers.id  order by `sellers`.`created_at` desc ") );
         return $Sellers;  


   }
   public static function listofseller()
   {
          $user_id= Auth::user()->id;
	  $Sellers1=array();
         $Sellers = Sellers::select("sellers.seller_name",'sellers.id','sellers.marketplace_name')->leftjoin('user_seller_int','user_seller_int.seller_id','=','sellers.id')
                            ->where("sellers.status","=","Active")->where('user_seller_int.user_id',$user_id)->orderBy('sellers.seller_name', 'asc')
                                         ->get()->toArray();
              foreach ($Sellers as $key => $value) {
                $Sellers1[$value['id']]=$value['seller_name'].' ('.Helper::getModuleName($value['marketplace_name']).')';
              }

         return $Sellers1;
   }
   /**
     check first seller or not
        HR - 2019
    */
   public static function checkseller_first()
   {
        $user_id= Auth::user()->id;
         $Sellers = Sellers::select('sellers.id','sellers.seller_name')->leftjoin('user_seller_int','user_seller_int.seller_id','=','sellers.id')
                            ->where("sellers.status","=","Active")->where('user_seller_int.user_id',$user_id)->orderBy('sellers.seller_name', 'desc')->first();
                            $seller_id ='';
                            if($Sellers){
                              $users = User::where('id',$user_id)->first();
                              if($users->current_selller_id_inuse!=""){
                                $seller_id =$users->current_selller_id_inuse;
                              }else{
                                $seller_id =$Sellers->id;
                              } 
                               
                            }else{
                              $seller_id ='';
                            }
         return $seller_id;  


   }

   public static function getSellerDetailsMarketPlaceWise($seller_id='',$az_marketplace_id)
    {
      $sellerdetails = Sellers::select('sellers.id','sellers.seller_name','sellers.az_app_token','sellers.az_seller_id','seller_marketplace_id.az_marketplace_id','seller_marketplace_id.id as seller_marketplace_id','sync_settings.*')
      ->join('qbo_credential','qbo_credential.seller_id','=','sellers.id')
      ->join('sync_settings','sync_settings.seller_id','=','sellers.id')
      ->join('seller_marketplace_id','seller_marketplace_id.seller_id','=','sellers.id')
      ->where('seller_marketplace_id.status','Active')
      ->where('sellers.id',$seller_id)
      ->where('seller_marketplace_id.az_marketplace_id',$az_marketplace_id)->first();
      
      return $sellerdetails;
   }

   public static function checkSourceDataUserWise(){
        $qbConnectionCheck = Sellers::select(DB::raw("CONCAT(sellers.id,'-',sellers.az_seller_id,' | ',sellers.seller_name) AS store_domain"),"sellers.id As id")
                            ->join("qbo_credential","qbo_credential.seller_id" , "=" , "sellers.id")
                            ->join('user_seller_int','user_seller_int.seller_id','=','sellers.id')
                            ->whereNull('sellers.deleted_at')
                            ->where('user_seller_int.user_id',Auth::user()->id)
                            //->where("sellers.status","Active")
                            ->orderBy("sellers.id","DESC")->pluck("store_domain","id")->all();

        return $qbConnectionCheck;
    }
    /*
    Check for seller avilable or not
    DG- 07-04-2020
   */ 
    public static function getSellerInfoSellerId($az_seller_id,$marketplace_name)
    {
      $sellerInfo = Sellers::select('sellers.*')
      ->join('user_seller_int','user_seller_int.seller_id','=','sellers.id')
      ->where('user_seller_int.user_id',Auth::user()->id)
      ->where('az_seller_id',$az_seller_id)
      ->where('marketplace_name',$marketplace_name)->first();
      return $sellerInfo;
    }
}
