<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class TallyConnection extends Model
{
    use HasFactory;
    protected $connection             = 'tally';
    protected $dates                  = [''];
    protected $table                  = 'tally_connections';
    protected $rules                  = array();
    protected $injectUniqueIdentifier = true;

    protected $fillable = ['username','password','company_name','tallyConnectionId','seller_id','module'];

    public static function checkTallyConnection($seller_id, $module)
    {
       return  TallyConnection::where("seller_id",$seller_id)
        ->where("status","Active")
        ->where("module", $module)
        ->first();
       
    }
    public static function createUser($data,$tallyConnectionId)
    {
        return $newUser = TallyConnection::updateOrCreate([
            //Add unique field combo to match here
            //For example, perhaps you only want one entry per user:
            'username'   => $data['username'],
            'seller_id' => $data['seller_id'],
            'module' => $data['module']
        ],[
            'username'=> $data['username'],
            'seller_id'=> $data['seller_id'],
            'password' => $data['password'],
            'company_name'=> $data['companyName'],
            'tallyConnectionId'    => $tallyConnectionId,
            'module' => $data['module'],
        ]);
       
    }

    public static function updateConnection($seller_id,$module,$connection_id, $updateConnectionData)
    {
        TallyConnection::where("seller_id",$seller_id)
        ->where("status","Active")
        ->where("module", $module)
        ->where('tallyConnectionId', $connection_id)
        ->update($updateConnectionData);
    }

    public static function updateAccountFlag($seller_id, $module)
    {
        TallyConnection::where('seller_id' , $seller_id)->where('module', $module)->update(['account_flag' => 1]);
    }

}
