<?php
namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Log;

class Tallycronongoing extends Model
{
    protected $dates      = [''];
    protected $connection = 'tally';
    protected $table      = 'tally_cron_ongoing';
    public $timestamps    = false;

    public static function checkCronOnGoing($seller_id, $module)
    {
        $result = Tallycronongoing::where("seller_id", $seller_id)->where("module", $module)->first();
        if(!empty($result)){
            // check for time difference and if difference is more than 2h then delete that cron and create another one.
            $startTime = strtotime($result['created_at']);
            $startTime2 = time();
            $total_time = ($startTime2 - $startTime)/3600;
            if($total_time > 2 && empty($result['note'])){
                Log::info('local.ERROR: Cron was Already Running of past time: '.$result['created_at'].'  & Seller: '.$seller_id.' ('.$module.')');
                Tallycronongoing::where("seller_id", $seller_id)->where("module", $module)->whereNull('note')->delete();
                return array(); //Empty array means no cron on going so it will create new cron and execute the code
            }
        }
        return $result;
    }

    public static function createCronOnGoing($seller_id, $module, $task)
    {
        $ssobj = new Tallycronongoing();
        $ssobj->seller_id = $seller_id;
        $ssobj->module = $module;
        $ssobj->action = $task;
        $ssobj->server_id = env('SERVER_ID');
        $ssobj->save();
    }

    public static function deleteCronOnGoing($seller_id, $module)
    {
        return Tallycronongoing::where("seller_id", $seller_id)->where("module", $module)->whereNull('note')->delete();
    }

    public static function getModuleBaseCron($module){
        return Tallycronongoing::where("module", $module)->whereNull('note')->get();
    }
}
