<?php

namespace App\Models;

use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Database\Eloquent\Model;

class Tallypayments extends Model
{
    protected $connection             = 'tally';
    protected $dates                  = [''];
    protected $table                  = 'tally_payments';
    protected $rules                  = array();
    protected $injectUniqueIdentifier = true;

    public static function fetchUnsyncReceipt($tallyConnected, $request, $task = 'create', $ids = array())
    {
        $orderStatus = ($request->get('status') != '') ? (array) $request->get('status') : array('New','Sync');
        $orderLimit  = ($request->get('limit') != '') ? $request->get('limit') : config('mastertallyconstant.OrderSyncLimitFromDB');
        $tally_order_id = ($request->get('tally_order_id') != '') ? explode(",", $request->get('tally_order_id')) : '';

        $orderObj = Tallypayments::where('seller_id', $tallyConnected['seller_id'])
            ->where('module', $tallyConnected['module'])
            ->orderBy('payment_date', 'ASC');

        if (!empty($tally_order_id)) {
            $orderObj = $orderObj->whereIn('tally_order_id', $tally_order_id);
        }else{
            if($task == 'create'){
                $orderLimit  = ($request->get('limit') != '') ? $request->get('limit') : config('mastertallyconstant.OrderSyncLimitFromDB');
                $orderObj = $orderObj
                ->where(function($query){
                            $query->where('sync_flag','N');
                            $query->orWhere('sync_flag', 'P');
                        })->whereIn('sync_status', $orderStatus)->limit($orderLimit);
            } else {
                $orderLimit  = ($request->get('limit') != '') ? $request->get('limit') : config('mastertallyconstant.OrderUpdateSyncLimitFromDB');
                $orderObj = $orderObj->where(function($query){
                            $query->where('sync_flag','N');
                            $query->orWhere('sync_flag', 'P');
                        })->where('sync_status', 'Sync')->whereNotNull('tally_id')->limit($orderLimit);
            }
        }

        if(!empty($ids)){
            $orderObj = $orderObj->whereNotIn('id', $ids);
        }
        //using pluck get all order_id in array
        $orderIdsObj = $orderObj->pluck('id')->toArray();
        $orderObj    = $orderObj->get()->toArray();
        return $orderObj;
    }

    public static function updatePaymentData($voucherId, $extraData)
    {
        Tallypayments::where('id',$extraData->receipt_id)->where('module', $extraData->module)->where('seller_id', $extraData->seller_id)->update(['tally_id' => $voucherId, 'sync_flag' => 'Y', 'sync_status' => 'Sync']);
    }

    public static function updatePaymentStatus($data, $status)
    {
        Tallypayments::where('id',$data['receipt_id'])->where('module', $data['module'])->where('seller_id', $data['seller_id'])->update(['sync_status' => $status]);
    }

    public static function getPaymentsByOrderId($seller_id,$module,$tally_order_id){
        return Tallypayments::where('seller_id', $seller_id)->where('module',$module)->where('tally_order_id',$tally_order_id)->get()->toArray();
    }
}
