<?php

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\Common\TallylibraryController;
use App\Http\Controllers\Common\AccountsController;
use App\Http\Controllers\Common\CompanyController;
use App\Http\Controllers\Individual\InvoiceController;
use App\Http\Controllers\Individual\ReceiptController;
use App\Http\Controllers\Individual\JournalvoucherController;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

Route::middleware('auth:sanctum')->get('/user', function (Request $request) {
    return $request->user();
});

Route::controller(TallylibraryController::class)->group(function () {
    Route::post('/connect', 'connect');
    Route::post('/regeneratefile', 'reGenerateFile');
    Route::post('/tallyResponse', 'tallyResponse');

});

Route::controller(AccountsController::class)->group(function () {
    Route::post('/getAccounts', 'getAccounts');
    Route::post('/createAccounts', 'createAccounts');
    Route::post('/createTaxAccount', 'createTaxAccount');

});

Route::controller(InvoiceController::class)->group(function () {
    //Route::get('/summary/{id}', 'index');
    Route::get('/getAccounts', 'getAccounts');
    Route::post('/createJournalVoucher', 'createJournalVoucher');
});

Route::controller(CompanyController::class)->group(function () {
   Route::post('/updateCompany', 'updateCompany');
   Route::post('/companyList', 'companyList');
});

Route::controller(InvoiceController::class)->group(function () {
    //Route::get('/summary/{id}', 'index');
    // Route::get('/getAccounts', 'getAccounts');
    Route::post('/createOrderInvoice', 'createOrderInvoice');
    Route::post('/createRefundCreditNote', 'createRefundCreditNote');
});
Route::controller(ReceiptController::class)->group(function () {
    Route::post('/createReceipt', 'createReceipt');
});
Route::controller(JournalvoucherController::class)->group(function () {
    Route::post('/createJournalVoucher', 'createJournalVoucher');
});
